Bug 1737426 - fedpkg fails to build on Fedora 31+ [NEEDINFO]
Summary: fedpkg fails to build on Fedora 31+
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: fedpkg
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
urgent
Target Milestone: ---
Assignee: cqi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON38 F31FTBFS
TreeView+ depends on / blocked
 
Reported: 2019-08-05 10:56 UTC by Miro Hrončok
Modified: 2019-08-21 10:17 UTC (History)
6 users (show)

Fixed In Version: fedpkg-1.37-9.fc32, fedpkg-1.37-9.fc31
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-08-21 10:17:49 UTC
mhroncok: needinfo? (cqi)


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Fedora Pagure fedpkg issue 349 None None None 2019-08-13 22:43:49 UTC

Description Miro Hrončok 2019-08-05 10:56:21 UTC
fedpkg fails to build with Python 3.8.0b3.


======================================================================
ERROR: test_create_update_in_stage_bodhi (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/usr/lib64/python3.8/configparser.py", line 789, in get
    value = d[option]
  File "/usr/lib64/python3.8/collections/__init__.py", line 891, in __getitem__
    return self.__missing__(key)            # support subclasses that define __missing__
  File "/usr/lib64/python3.8/collections/__init__.py", line 883, in __missing__
    raise KeyError(key)
KeyError: 'display_name'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 702, in update
    self.cmd.update(bodhi_config, template=bodhi_template_file)
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/__init__.py", line 277, in update
    update_details = bodhi.parse_file(template)
  File "/usr/lib/python3.8/site-packages/bodhi/client/bindings.py", line 625, in parse_file
    'display_name': config.get(section, 'display_name', raw=True),
  File "/usr/lib64/python3.8/configparser.py", line 792, in get
    raise NoOptionError(option, section)
configparser.NoOptionError: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 272, in test_create_update_in_stage_bodhi
    self.assert_bodhi_update(cli, update_type='enhancement')
  File "/usr/lib/python3.8/site-packages/mock/mock.py", line 1330, in patched
    return func(*args, **keywargs)
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 199, in assert_bodhi_update
    cli.update()
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 708, in update
    raise rpkgError('Could not generate update request: %s\n'
pyrpkg.errors.rpkgError: Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last

======================================================================
ERROR: test_create_with_cli_options (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/usr/lib64/python3.8/configparser.py", line 789, in get
    value = d[option]
  File "/usr/lib64/python3.8/collections/__init__.py", line 891, in __getitem__
    return self.__missing__(key)            # support subclasses that define __missing__
  File "/usr/lib64/python3.8/collections/__init__.py", line 883, in __missing__
    raise KeyError(key)
KeyError: 'display_name'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 702, in update
    self.cmd.update(bodhi_config, template=bodhi_template_file)
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/__init__.py", line 277, in update
    update_details = bodhi.parse_file(template)
  File "/usr/lib/python3.8/site-packages/bodhi/client/bindings.py", line 625, in parse_file
    'display_name': config.get(section, 'display_name', raw=True),
  File "/usr/lib64/python3.8/configparser.py", line 792, in get
    raise NoOptionError(option, section)
configparser.NoOptionError: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 305, in test_create_with_cli_options
    self.assert_bodhi_update(
  File "/usr/lib/python3.8/site-packages/mock/mock.py", line 1330, in patched
    return func(*args, **keywargs)
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 199, in assert_bodhi_update
    cli.update()
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 708, in update
    raise rpkgError('Could not generate update request: %s\n'
pyrpkg.errors.rpkgError: Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last

======================================================================
ERROR: test_create_with_notes_in_multiple_lines (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/usr/lib64/python3.8/configparser.py", line 789, in get
    value = d[option]
  File "/usr/lib64/python3.8/collections/__init__.py", line 891, in __getitem__
    return self.__missing__(key)            # support subclasses that define __missing__
  File "/usr/lib64/python3.8/collections/__init__.py", line 883, in __missing__
    raise KeyError(key)
KeyError: 'display_name'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 702, in update
    self.cmd.update(bodhi_config, template=bodhi_template_file)
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/__init__.py", line 277, in update
    update_details = bodhi.parse_file(template)
  File "/usr/lib/python3.8/site-packages/bodhi/client/bindings.py", line 625, in parse_file
    'display_name': config.get(section, 'display_name', raw=True),
  File "/usr/lib64/python3.8/configparser.py", line 792, in get
    raise NoOptionError(option, section)
configparser.NoOptionError: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 342, in test_create_with_notes_in_multiple_lines
    self.assert_bodhi_update(
  File "/usr/lib/python3.8/site-packages/mock/mock.py", line 1330, in patched
    return func(*args, **keywargs)
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 199, in assert_bodhi_update
    cli.update()
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 708, in update
    raise rpkgError('Could not generate update request: %s\n'
pyrpkg.errors.rpkgError: Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last

======================================================================
ERROR: test_request_update (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/usr/lib64/python3.8/configparser.py", line 789, in get
    value = d[option]
  File "/usr/lib64/python3.8/collections/__init__.py", line 891, in __getitem__
    return self.__missing__(key)            # support subclasses that define __missing__
  File "/usr/lib64/python3.8/collections/__init__.py", line 883, in __missing__
    raise KeyError(key)
KeyError: 'display_name'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 702, in update
    self.cmd.update(bodhi_config, template=bodhi_template_file)
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/__init__.py", line 277, in update
    update_details = bodhi.parse_file(template)
  File "/usr/lib/python3.8/site-packages/bodhi/client/bindings.py", line 625, in parse_file
    'display_name': config.get(section, 'display_name', raw=True),
  File "/usr/lib64/python3.8/configparser.py", line 792, in get
    raise NoOptionError(option, section)
configparser.NoOptionError: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 253, in test_request_update
    self.assert_bodhi_update(cli, update_type='enhancement')
  File "/usr/lib/python3.8/site-packages/mock/mock.py", line 1330, in patched
    return func(*args, **keywargs)
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 199, in assert_bodhi_update
    cli.update()
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 708, in update
    raise rpkgError('Could not generate update request: %s\n'
pyrpkg.errors.rpkgError: Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last

======================================================================
ERROR: test_show_editor_if_notes_is_omitted (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/usr/lib64/python3.8/configparser.py", line 789, in get
    value = d[option]
  File "/usr/lib64/python3.8/collections/__init__.py", line 891, in __getitem__
    return self.__missing__(key)            # support subclasses that define __missing__
  File "/usr/lib64/python3.8/collections/__init__.py", line 883, in __missing__
    raise KeyError(key)
KeyError: 'display_name'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 702, in update
    self.cmd.update(bodhi_config, template=bodhi_template_file)
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/__init__.py", line 277, in update
    update_details = bodhi.parse_file(template)
  File "/usr/lib/python3.8/site-packages/bodhi/client/bindings.py", line 625, in parse_file
    'display_name': config.get(section, 'display_name', raw=True),
  File "/usr/lib64/python3.8/configparser.py", line 792, in get
    raise NoOptionError(option, section)
configparser.NoOptionError: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 330, in test_show_editor_if_notes_is_omitted
    self.assert_bodhi_update(cli, update_type='bugfix')
  File "/usr/lib/python3.8/site-packages/mock/mock.py", line 1330, in patched
    return func(*args, **keywargs)
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 199, in assert_bodhi_update
    cli.update()
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 708, in update
    raise rpkgError('Could not generate update request: %s\n'
pyrpkg.errors.rpkgError: Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last

======================================================================
ERROR: test_show_editor_if_update_type_is_omitted (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/usr/lib64/python3.8/configparser.py", line 789, in get
    value = d[option]
  File "/usr/lib64/python3.8/collections/__init__.py", line 891, in __getitem__
    return self.__missing__(key)            # support subclasses that define __missing__
  File "/usr/lib64/python3.8/collections/__init__.py", line 883, in __missing__
    raise KeyError(key)
KeyError: 'display_name'

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 702, in update
    self.cmd.update(bodhi_config, template=bodhi_template_file)
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/__init__.py", line 277, in update
    update_details = bodhi.parse_file(template)
  File "/usr/lib/python3.8/site-packages/bodhi/client/bindings.py", line 625, in parse_file
    'display_name': config.get(section, 'display_name', raw=True),
  File "/usr/lib64/python3.8/configparser.py", line 792, in get
    raise NoOptionError(option, section)
configparser.NoOptionError: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 317, in test_show_editor_if_update_type_is_omitted
    self.assert_bodhi_update(
  File "/usr/lib/python3.8/site-packages/mock/mock.py", line 1330, in patched
    return func(*args, **keywargs)
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 199, in assert_bodhi_update
    cli.update()
  File "/builddir/build/BUILD/fedpkg-1.37/fedpkg/cli.py", line 708, in update
    raise rpkgError('Could not generate update request: %s\n'
pyrpkg.errors.rpkgError: Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last

======================================================================
FAIL: test_incorrect_request_type_in_template (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 292, in test_incorrect_request_type_in_template
    six.assertRaisesRegex(self, rpkgError, 'Incorrect request type',
  File "/usr/lib/python3.8/site-packages/six.py", line 677, in assertRaisesRegex
    return getattr(self, _assertRaisesRegex)(*args, **kwargs)
AssertionError: "Incorrect request type" does not match "Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last"


======================================================================
FAIL: test_incorrect_update_type_in_template (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 286, in test_incorrect_update_type_in_template
    six.assertRaisesRegex(self, rpkgError, 'Incorrect update type',
  File "/usr/lib/python3.8/site-packages/six.py", line 677, in assertRaisesRegex
    return getattr(self, _assertRaisesRegex)(*args, **kwargs)
AssertionError: "Incorrect update type" does not match "Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last"


======================================================================
FAIL: test_missing_update_type_in_template (test_cli.TestUpdate)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/fedpkg-1.37/test/test_cli.py", line 280, in test_missing_update_type_in_template
    six.assertRaisesRegex(self, rpkgError, 'Missing update type',
  File "/usr/lib/python3.8/site-packages/six.py", line 677, in assertRaisesRegex
    return getattr(self, _assertRaisesRegex)(*args, **kwargs)
AssertionError: "Missing update type" does not match "Could not generate update request: No option 'display_name' in section: ' fedpkg-1.29-9.fc27 '
A copy of the filled in template is saved as bodhi.template.last"


----------------------------------------------------------------------
Ran 156 tests in 12.700s

FAILED (errors=6, failures=3)

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.8/fedora-rawhide-x86_64/00995095-fedpkg/

For all our attempts to build fedpkg with Python 3.8, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.8/package/fedpkg/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.8:
https://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Let us know here if you have any questions.


We plan to start to build in the side tag next week.
Without functional fedpkg, we cannot ever merge the side tag to rawhide.
Hence, setting the severity to urgent.

Comment 1 Ben Cotton 2019-08-13 18:33:44 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 2 Miro Hrončok 2019-08-13 22:27:53 UTC
We plan to start to build in the side tomorrow.
Without functional fedpkg, we cannot ever merge the side tag to rawhide.

Comment 3 Miro Hrončok 2019-08-13 22:33:06 UTC
> in the side 

in the side tag

Comment 4 Miro Hrončok 2019-08-13 22:35:32 UTC
Apparently, fedpkg fails to build in regular Fedora 31 and 32 (with Python 3.7) as well:

f31: https://koji.fedoraproject.org/koji/taskinfo?taskID=37019414
f32: https://koji.fedoraproject.org/koji/taskinfo?taskID=37019424


Both ended with: FAILED (errors=6, failures=3)

Comment 5 Miro Hrončok 2019-08-13 22:38:37 UTC
The package was unfortunately not tracked in bodhi, but now it is:

Here is the buildroot diff from the last successful build:

    https://apps.fedoraproject.org/koschei/build/6802680

This one particular update might be the problem:

    python3-bodhi-client:
    - 4.0.2-2.fc31
    + 4.1.0-3.fc31

Since the error is:

    pyrpkg.errors.rpkgError: Could not generate update request: No option 'display_name' in section...

Comment 6 Miro Hrončok 2019-08-13 22:44:28 UTC
> tracked in bodhi

s/bodhi/koschei/

Comment 7 Miro Hrončok 2019-08-14 22:24:31 UTC
The coordinated rebuild of Python 3.8 has started in the `f32-python` side tag.

If you figure out how to rebuild this package, please don't rebuild it in regular rawhide, but use the side tag instead:

    on branch master:
    $ fedpkg build --target=f32-python

To wait for a build to show up in the side tag, do:

    $ koji wait-repo f32-python --build=<nvr>

Where <nvr> is name-version-release of the source package, e.g. python-foo-1.1-2.fc32.

An updated mock config is posted at:
http://copr.fedorainfracloud.org/coprs/g/python/python3.8/

Note that it will take a while before the essential packages are rebuilt, so don't expect all your dependencies to be available right away.

Thanks. Let us know if you need up to date info, or if you have any questions.



PS this message is mass posted to all the bugs that block the PYTHON38 bug. If this is also a Fedora 31 FTBFS bug and you manage to fix it, you can do a f31 build as usual:

    on branch f31:
    $ fedpkg build

Comment 8 Ondřej Nosek 2019-08-15 13:29:34 UTC
Hi,
I am sorry for a long investigation. There is a (temporary scratch) build for fedora 31 that could work:

https://koji.fedoraproject.org/koji/taskinfo?taskID=37054185
It !requires! bodhi-4.1.0-3

Please, try this. But it is just for testing purposes and verification. The issue started when Bodhi added feature/bug that allows a user to add display_name field in an update. But bodhi client requires this field. For mentioned fedpkg build I added this field into template and code. It works for Fedora31 and bodhi-4.1.0-3. Not for older bodhi client. I would have to update other versions of fedpkg but bodhi of that version is avaliable only for f31. I do not like to test available bodhi client in fedpkg and on upon of the test result customize bodhi client communication.
Isn't it possible to change this field in bodhi client from required/mandatory to optional? In the web interface, it is allowed not to fill it in.

Comment 9 Miro Hrončok 2019-08-15 13:32:47 UTC
> Isn't it possible to change this field in bodhi client from required/mandatory to optional? In the web interface, it is allowed not to fill it in.

That sounds like a proper fix.

Comment 10 Miro Hrončok 2019-08-15 13:43:49 UTC
That SRPM builds with 3.8 as well.

Comment 11 Ondřej Nosek 2019-08-15 15:33:55 UTC
I opened an issue for bodhi (I hope, this is the right issue tracker):

https://github.com/fedora-infra/bodhi/issues/3470

Comment 12 Miro Hrončok 2019-08-20 22:46:55 UTC
Can we get the short term workaround in place please?

Comment 13 Ondřej Nosek 2019-08-21 10:01:44 UTC
@mhroncok: We can. I prepared a build with the workaround: https://koji.fedoraproject.org/koji/buildinfo?buildID=1361791
But I can not create Bodhi update for this: "Builds : Cannot find release associated with build: fedpkg-1.37-9.fc31, tags: ['f31']"
I can see, the build is tagged into f31.

Comment 14 Miro Hrončok 2019-08-21 10:02:52 UTC
Bodhi is not active for f31.

Comment 15 Miro Hrončok 2019-08-21 10:17:49 UTC
Thanks.


Note You need to log in before you can comment on or make changes to this bug.